HDU 1969 Pie(二分搜索)

题目链接

Problem Description
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
 
Input
One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
 
Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
 
Sample Input
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2
 
Sample Output
25.1327
3.1416
50.2655

 题解:将n个蛋糕分给m+1个人,但是每个人只能拿到一块(不能拼凑),每块大小要相同(形状不用相同),问每个人最多能分到多大的蛋糕(面积)。思路是先求出面积,用数组保存,并排序。L为0,R为最大的那个蛋糕的面积,然后二分搜索。

#include <cstdio>
#include <iostream>
#include <string>
#include <sstream>
#include <cstring>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
#define PI acos(-1.0)
#define ms(a) memset(a,0,sizeof(a))
#define msp memset(mp,0,sizeof(mp))
#define msv memset(vis,0,sizeof(vis))
using namespace std;
//#define LOCAL
int n,m;
double a[10001];
bool check(double x)
{
    int cnt=0;
    for(int i=0; i<n; i++)
    {
        cnt+=int(a[i]/x);
        if(cnt>=m)return 1;
    }
    return 0;
}
bool cmp(double a,double b)
{
    return a>b;
}
int main()
{
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(false);
    int N;
    cin>>N;
    while(N--)
    {
        //int n,m;
        cin>>n>>m;
        m++;
        ms(a);
        for(int i=0; i<n; i++)
        {
            cin>>a[i];
            a[i]=a[i]*a[i]*PI;
        }
        sort(a,a+n,cmp);
        double l=0,r=a[0],mid;
        if(m<n)n=m;//即使前面m个不够,后面的也没用,这样可以省点时间
        while(r-l>1e-5)
        {
            mid=(r+l)/2;
            if(check(mid))l=mid;
            else r=mid;
        }
        printf("%.4lf
",l);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/gpsx/p/5182138.html